from http import HTTPStatus
from typing import Any

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.awb import Awb
from ...models.cws_error_dto import CwsErrorDTO
from ...types import Response


def _get_kwargs(
    *,
    body: Awb,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> dict[str, Any]:
    headers: dict[str, Any] = {}
    headers["Authorization"] = authorization

    _kwargs: dict[str, Any] = {
        "method": "post",
        "url": "/dpi/shipping/v1/awbs",
    }

    _kwargs["json"] = body.to_dict()

    headers["Content-Type"] = "application/json"

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> Awb | CwsErrorDTO | None:
    if response.status_code == 200:
        response_200 = Awb.from_dict(response.json())

        return response_200

    if response.status_code == 403:
        response_403 = CwsErrorDTO.from_dict(response.json())

        return response_403

    if response.status_code == 404:
        response_404 = CwsErrorDTO.from_dict(response.json())

        return response_404

    if response.status_code == 422:
        response_422 = CwsErrorDTO.from_dict(response.json())

        return response_422

    if response.status_code == 500:
        response_500 = CwsErrorDTO.from_dict(response.json())

        return response_500

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(*, client: AuthenticatedClient | Client, response: httpx.Response) -> Response[Awb | CwsErrorDTO]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    *,
    client: AuthenticatedClient | Client,
    body: Awb,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[Awb | CwsErrorDTO]:
    """Create a Single AWB

     Creates a new single awb based on the given data. This request will be decommissioned. Please use
    /dpi/v1/bulk/{customerEkp}/mixedorders instead.

    Args:
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (Awb):  Example: {'customerEkp': '9012345678', 'contactName': 'Max Mustermann',
            'awbCopyCount': 3, 'product': 'GMP', 'serviceLevel': 'PRIORITY', 'itemFormat': 'P',
            'jobReference': 'Job ref', 'totalWeight': 5, 'telephoneNumber': '+4935120681234'}.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Awb | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        body=body,
        authorization=authorization,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    *,
    client: AuthenticatedClient | Client,
    body: Awb,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Awb | CwsErrorDTO | None:
    """Create a Single AWB

     Creates a new single awb based on the given data. This request will be decommissioned. Please use
    /dpi/v1/bulk/{customerEkp}/mixedorders instead.

    Args:
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (Awb):  Example: {'customerEkp': '9012345678', 'contactName': 'Max Mustermann',
            'awbCopyCount': 3, 'product': 'GMP', 'serviceLevel': 'PRIORITY', 'itemFormat': 'P',
            'jobReference': 'Job ref', 'totalWeight': 5, 'telephoneNumber': '+4935120681234'}.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Awb | CwsErrorDTO
    """

    return sync_detailed(
        client=client,
        body=body,
        authorization=authorization,
    ).parsed


async def asyncio_detailed(
    *,
    client: AuthenticatedClient | Client,
    body: Awb,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Response[Awb | CwsErrorDTO]:
    """Create a Single AWB

     Creates a new single awb based on the given data. This request will be decommissioned. Please use
    /dpi/v1/bulk/{customerEkp}/mixedorders instead.

    Args:
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (Awb):  Example: {'customerEkp': '9012345678', 'contactName': 'Max Mustermann',
            'awbCopyCount': 3, 'product': 'GMP', 'serviceLevel': 'PRIORITY', 'itemFormat': 'P',
            'jobReference': 'Job ref', 'totalWeight': 5, 'telephoneNumber': '+4935120681234'}.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[Awb | CwsErrorDTO]
    """

    kwargs = _get_kwargs(
        body=body,
        authorization=authorization,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    *,
    client: AuthenticatedClient | Client,
    body: Awb,
    authorization: str = "Bearer [place  OAuth access_token here, without brackets]",
) -> Awb | CwsErrorDTO | None:
    """Create a Single AWB

     Creates a new single awb based on the given data. This request will be decommissioned. Please use
    /dpi/v1/bulk/{customerEkp}/mixedorders instead.

    Args:
        authorization (str):  Default: 'Bearer [place  OAuth access_token here, without
            brackets]'.
        body (Awb):  Example: {'customerEkp': '9012345678', 'contactName': 'Max Mustermann',
            'awbCopyCount': 3, 'product': 'GMP', 'serviceLevel': 'PRIORITY', 'itemFormat': 'P',
            'jobReference': 'Job ref', 'totalWeight': 5, 'telephoneNumber': '+4935120681234'}.

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Awb | CwsErrorDTO
    """

    return (
        await asyncio_detailed(
            client=client,
            body=body,
            authorization=authorization,
        )
    ).parsed
